"""Labels."""

monitoring_labels: "list[dict[str, str | bool]]" = [
    {
        "name": "num_pages",
        "data_type": "int",
        "display_name": "Number of Pages",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
]

octopus_labels: "list[dict[str, str | bool]]" = [
    {
        "name": "audit_viewing",
        "data_type": "string",
        "display_name": "Audit Viewing",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "company_cif",
        "data_type": "string",
        "display_name": "Company CIF",
        "visible": True,
        "searchable": True,
        "typeahead": True,
        "analysed": True,
    },
    {
        "name": "company_name",
        "data_type": "string",
        "display_name": "Company Name",
        "visible": True,
        "searchable": True,
        "typeahead": True,
        "analysed": True,
    },
    {
        "name": "company_name_pred",
        "data_type": "string",
        "display_name": "Company Name Predicted",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "company_name_true",
        "data_type": "string",
        "display_name": "Company Name True",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "company_uid",
        "data_type": "string",
        "display_name": "Company UID",
        "visible": True,
        "searchable": True,
        "typeahead": True,
        "analysed": True,
    },
    {
        "name": "cso_name",
        "data_type": "string",
        "display_name": "CSO Name",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "current_doc_status",
        "data_type": "string",
        "display_name": "Current Status Code",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "current_doc_status_header",
        "data_type": "string",
        "display_name": "Current Status",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "document_category",
        "data_type": "string",
        "display_name": "Document Category",
        "visible": True,
        "searchable": True,
        "typeahead": True,
        "analysed": True,
    },
    {
        "name": "document_date",
        "data_type": "datetime",
        "display_name": "Document Date",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_date_pred",
        "data_type": "datetime",
        "display_name": "Document Date Predicted",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_date_true",
        "data_type": "datetime",
        "display_name": "Document Date True",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_hash",
        "data_type": "string",
        "display_name": "Document Hash",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_format",
        "data_type": "string",
        "display_name": "Document Format",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "document_reference",
        "data_type": "string",
        "display_name": "Document Reference",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "document_type",
        "data_type": "string",
        "display_name": "Document Type",
        "visible": True,
        "searchable": True,
        "typeahead": True,
        "analysed": True,
    },
    {
        "name": "document_type_pred",
        "data_type": "string",
        "display_name": "Document Type Predicted",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_type_pred_ml",
        "data_type": "string",
        "display_name": "Document Type ML",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_type_pred_rb",
        "data_type": "string",
        "display_name": "Document Type RB",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "document_type_true",
        "data_type": "string",
        "display_name": "Document Type True",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "end_time",
        "data_type": "int",
        "display_name": "End Time",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "notes",
        "data_type": "string",
        "display_name": "Notes",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "num_pages",
        "data_type": "int",
        "display_name": "Number of Pages",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "permission_code",
        "data_type": "string",
        "display_name": "Permission Code",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "references",
        "data_type": "string",
        "display_name": "References",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "rm_name",
        "data_type": "string",
        "display_name": "RM Name",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "start_time",
        "data_type": "int",
        "display_name": "Start Time",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "time_taken",
        "data_type": "int",
        "display_name": "Time Taken",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "uid_permission_code",
        "data_type": "string",
        "display_name": "UID Permission Code Tuple",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "user_email",
        "data_type": "string",
        "display_name": "User Email",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "user_name",
        "data_type": "string",
        "display_name": "User Name",
        "visible": True,
        "searchable": False,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "wfi_company_rm_code",
        "data_type": "string",
        "display_name": "WFI Company RM Code",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_company_segment",
        "data_type": "string",
        "display_name": "WFI Company Segment",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_company_team_name",
        "data_type": "string",
        "display_name": "WFI Company Team Name",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_document_category",
        "data_type": "string",
        "display_name": "WFI Document Category",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_document_date",
        "data_type": "datetime",
        "display_name": "WFI Document Date",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_document_id",
        "data_type": "string",
        "display_name": "WFI Document ID",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": True,
    },
    {
        "name": "wfi_document_name",
        "data_type": "string",
        "display_name": "WFI Document Name",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_document_type",
        "data_type": "string",
        "display_name": "WFI Document Type",
        "visible": False,
        "searchable": False,
        "typeahead": False,
        "analysed": False,
    },
    {
        "name": "wfi_status",
        "data_type": "string",
        "display_name": "WFI Status",
        "visible": True,
        "searchable": True,
        "typeahead": False,
        "analysed": True,
    },
]
