"""Store status_trial index for report generation.

Revision ID: cc37004420b3
Revises: a3492d17696a
Create Date: 2024-09-04 08:10:11.021105
"""

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision: str = "cc37004420b3"
down_revision: str | None = "a3492d17696a"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "document_status",
        sa.Column("status_trail_report_idx", sa.Integer(), nullable=True),
    )
    op.drop_column("document_status", "updated_timestamp_report")
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "document_status",
        sa.Column("updated_timestamp_report", mysql.DATETIME(), nullable=True),
    )
    op.drop_column("document_status", "status_trail_report_idx")
    # ### end Alembic commands ###
