ace.define("ace/mode/maze_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(r,s,k){"use strict";var u=r("../lib/oop"),m=r("./text_highlight_rules").TextHighlightRules,g=function(){this.$rules={start:[{token:"keyword.control",regex:/##|``/,comment:"Wall"},{token:"entity.name.tag",regex:/\.\./,comment:"Path"},{token:"keyword.control",regex:/<>/,comment:"Splitter"},{token:"entity.name.tag",regex:/\*[\*A-Za-z0-9]/,comment:"Signal"},{token:"constant.numeric",regex:/[0-9]{2}/,comment:"Pause"},{token:"keyword.control",regex:/\^\^/,comment:"Start"},{token:"keyword.control",regex:/\(\)/,comment:"Hole"},{token:"support.function",regex:/>>/,comment:"Out"},{token:"support.function",regex:/>\//,comment:"Ln Out"},{token:"support.function",regex:/<</,comment:"In"},{token:"keyword.control",regex:/--/,comment:"One use"},{token:"constant.language",regex:/%[LRUDNlrudn]/,comment:"Direction"},{token:["entity.name.function","keyword.other","keyword.operator","keyword.other","keyword.operator","constant.numeric","keyword.operator","keyword.other","keyword.operator","constant.numeric","string.quoted.double","string.quoted.single"],regex:/([A-Za-z][A-Za-z0-9])( *-> *)(?:([-+*\/]=)( *)((?:-)?)([0-9]+)|(=)( *)(?:((?:-)?)([0-9]+)|("[^"]*")|('[^']*')))/,comment:"Assignment function"},{token:["entity.name.function","keyword.other","keyword.control","keyword.other","keyword.operator","keyword.other","keyword.operator","constant.numeric","entity.name.tag","keyword.other","keyword.control","keyword.other","constant.language","keyword.other","keyword.control","keyword.other","constant.language"],regex:/([A-Za-z][A-Za-z0-9])( *-> *)(IF|if)( *)(?:([<>]=?|==)( *)((?:-)?)([0-9]+)|(\*[\*A-Za-z0-9]))( *)(THEN|then)( *)(%[LRUDNlrudn])(?:( *)(ELSE|else)( *)(%[LRUDNlrudn]))?/,comment:"Equality Function"},{token:"entity.name.function",regex:/[A-Za-z][A-Za-z0-9]/,comment:"Function cell"},{token:"comment.line.double-slash",regex:/ *\/\/.*/,comment:"Comment"}]},this.normalizeRules()};g.metaData={fileTypes:["mz"],name:"Maze",scopeName:"source.maze"},u.inherits(g,m),s.MazeHighlightRules=g}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(r,s,k){"use strict";var u=r("../../lib/oop"),m=r("../../range").Range,g=r("./fold_mode").FoldMode,f=s.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};u.inherits(f,g),function(){this.foldingStartMarker=/([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,t,o){var a=e.getLine(o);if(this.singleLineBlockCommentRe.test(a)&&!this.startRegionRe.test(a)&&!this.tripleStarBlockCommentRe.test(a))return"";var i=this._getFoldWidgetBase(e,t,o);return!i&&this.startRegionRe.test(a)?"start":i},this.getFoldWidgetRange=function(e,t,o,a){var i=e.getLine(o);if(this.startRegionRe.test(i))return this.getCommentRegionBlock(e,i,o);var n=i.match(this.foldingStartMarker);if(n){var c=n.index;if(n[1])return this.openingBracketBlock(e,n[1],o,c);var l=e.getCommentFoldRange(o,c+n[0].length,1);return l&&!l.isMultiLine()&&(a?l=this.getSectionRange(e,o):t!="all"&&(l=null)),l}if(t!=="markbegin"){var n=i.match(this.foldingStopMarker);if(n){var c=n.index+n[0].length;return n[1]?this.closingBracketBlock(e,n[1],o,c):e.getCommentFoldRange(o,c,-1)}}},this.getSectionRange=function(e,t){var o=e.getLine(t),a=o.search(/\S/),i=t,c=o.length;t=t+1;for(var l=t,n=e.getLength();++t<n;){o=e.getLine(t);var h=o.search(/\S/);if(h!==-1){if(a>h)break;var d=this.getFoldWidgetRange(e,"all",t);if(d){if(d.start.row<=i)break;if(d.isMultiLine())t=d.end.row;else if(a==h)break}l=t}}return new m(i,c,l,e.getLine(l).length)},this.getCommentRegionBlock=function(e,t,o){for(var a=t.search(/\s*$/),i=e.getLength(),c=o,l=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,n=1;++o<i;){t=e.getLine(o);var h=l.exec(t);if(h&&(h[1]?n--:n++,!n))break}var d=o;if(d>c)return new m(c,a,d,t.length)}}.call(f.prototype)}),ace.define("ace/mode/maze",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/maze_highlight_rules","ace/mode/folding/cstyle"],function(r,s,k){"use strict";var u=r("../lib/oop"),m=r("./text").Mode,g=r("./maze_highlight_rules").MazeHighlightRules,f=r("./folding/cstyle").FoldMode,e=function(){this.HighlightRules=g,this.foldingRules=new f,this.$behaviour=this.$defaultBehaviour};u.inherits(e,m),function(){this.lineCommentStart="//",this.$id="ace/mode/maze",this.snippetFileId="ace/snippets/maze"}.call(e.prototype),s.Mode=e}),function(){ace.require(["ace/mode/maze"],function(r){typeof module=="object"&&typeof exports=="object"&&module&&(module.exports=r)})}();
